<?php

namespace DataView;

class Fop_fints_file_konto {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderTabTableAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((\FOP\User::getBuchhaltung()))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="var self = this; $.get(reloadfop_fints_file_konto({action: 'open', fop_table: 'fop_fints_file', fop_id: '_', fop_from: location.href}, true)).then(function () { open_url(self.href, false);}); return false;" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::createURL2(['from' => \FOP\Util::getBackUrl(), 'column_konto' => $id])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('SEPA-Datei'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_fop_fints_file_konto']) ? intval($_GET['page_fop_fints_file_konto']) : 0);
								$addlines = (isset($_GET['addlines_fop_fints_file_konto']) ? intval($_GET['addlines_fop_fints_file_konto']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET, $id);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'status',
												'desc' => _('Status'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['status'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'file',
												'desc' => _('SEPA-Datei'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['file'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'dateCreation',
												'desc' => _('Erstelldatum'),
												'order' => ++$order,
												'width' => 100, // default value
												'collapsed' => 0

											];
											$columns['dateCreation'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'dateExecution',
												'desc' => _('Durchführungsdatum'),
												'order' => ++$order,
												'width' => 100, // default value
												'collapsed' => 0

											];
											$columns['dateExecution'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'message',
												'desc' => _('Meldung Transaktion'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['message'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('fop_fints_file_konto'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='status'
												data-order='<?php echo intval($columns['status']['order']); ?>'
												data-width='<?php echo intval($columns['status']['width']); ?>'
												data-collapsed='<?php echo intval($columns['status']['collapsed']); ?>'
												style='width: <?php echo intval($columns['status']['width']); ?>px; <?php if ($columns['status']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_file_konto(); 
		}});
		win.append($('<input type=\'checkbox\'' + (querySet('filter_fop_fints_file_konto_status', '1') ? ' checked>': '>')).change(function (){querySet('filter_fop_fints_file_konto_status', '1', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Neu')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_fop_fints_file_konto_status', '2') ? ' checked>': '>')).change(function (){querySet('filter_fop_fints_file_konto_status', '2', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Erfolg')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_fop_fints_file_konto_status', '3') ? ' checked>': '>')).change(function (){querySet('filter_fop_fints_file_konto_status', '3', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Datei-Fehler')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_fop_fints_file_konto_status', '4') ? ' checked>': '>')).change(function (){querySet('filter_fop_fints_file_konto_status', '4', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('TAN-Fehler')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_fop_fints_file_konto_status', '5') ? ' checked>': '>')).change(function (){querySet('filter_fop_fints_file_konto_status', '5', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('Abgebrochen')); ?><br/>').append($('<input type=\'checkbox\'' + (querySet('filter_fop_fints_file_konto_status', '6') ? ' checked>': '>')).change(function (){querySet('filter_fop_fints_file_konto_status', '6', $(this).prop('checked')); changed=true;})).append('<span> </span><?php echo(_('extern durchgeführt')); ?><br/>');
		return false;
	">
													<span class='title-title' title='<?php echo(_('Status')); ?>'><?php echo(_('Status')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'status ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'status DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_file_konto_status']) || isset($_GET['range_max_fop_fints_file_konto_status']) || isset($_GET['deps_fop_fints_file_konto_status']) || isset($_GET['fullsearch_fop_fints_file_konto_status']) || isset($_GET['dynamic_fop_fints_file_konto_status']) || isset($_GET['search_fop_fints_file_konto_status']) || isset($_GET['searchnot_fop_fints_file_konto_status']) || isset($_GET['filter_fop_fints_file_konto_status'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['status']['header'] = ob_get_contents(); ob_end_clean();
											$columns['status']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['status']['width']); ?>px; <?php if ($columns['status']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='status'><?php echo htmlentities(\Types\Fop_fints_file_state::toStringShort($item['status'])); ?></div><?php
											};
											$columns['status']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='status'
													data-order='<?php echo intval($columns['status']['order']); ?>'
													data-width='<?php echo intval($columns['status']['width']); ?>'
													data-collapsed='<?php echo intval($columns['status']['collapsed']); ?>'
													style='width: <?php echo intval($columns['status']['width']); ?>px; <?php if ($columns['status']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='file'
												data-order='<?php echo intval($columns['file']['order']); ?>'
												data-width='<?php echo intval($columns['file']['width']); ?>'
												data-collapsed='<?php echo intval($columns['file']['collapsed']); ?>'
												style='width: <?php echo intval($columns['file']['width']); ?>px; <?php if ($columns['file']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_file_konto(); 
		}});
		var el, text;
		win.append(el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		text = el.find('input');
		text.val(query['fullsearch_fop_fints_file_konto_file']);
		text.on('change keyup paste', function () { query['fullsearch_fop_fints_file_konto_file'] = text.val(); delete query['page_fop_fints_file_konto']; changed = true; });
		text.focus();
		text.select();
		return false;
	">
													<span class='title-title' title='<?php echo(_('SEPA-Datei')); ?>'><?php echo(_('SEPA-Datei')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'file ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'file DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_file_konto_file']) || isset($_GET['range_max_fop_fints_file_konto_file']) || isset($_GET['deps_fop_fints_file_konto_file']) || isset($_GET['fullsearch_fop_fints_file_konto_file']) || isset($_GET['dynamic_fop_fints_file_konto_file']) || isset($_GET['search_fop_fints_file_konto_file']) || isset($_GET['searchnot_fop_fints_file_konto_file']) || isset($_GET['filter_fop_fints_file_konto_file'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['file']['header'] = ob_get_contents(); ob_end_clean();
											$columns['file']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['file']['width']); ?>px; <?php if ($columns['file']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='file'><?php if ($item['file']) { ?><a target='_blank' onclick='event.stopPropagation()' href='fop-files/<?php echo urlencode(htmlentities($item['file'])); ?>/x'><?php call_user_func(function($v) { $result = \FOP\Database::query('SELECT filename FROM fop_files WHERE '.qi('ID').' = '.intval($v))->fetch(\PDO::FETCH_ASSOC); echo htmlentities($result['filename']); }, $item['file']); ?></a><?php } else { echo '-'; } ?></div><?php
											};
											$columns['file']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='file'
													data-order='<?php echo intval($columns['file']['order']); ?>'
													data-width='<?php echo intval($columns['file']['width']); ?>'
													data-collapsed='<?php echo intval($columns['file']['collapsed']); ?>'
													style='width: <?php echo intval($columns['file']['width']); ?>px; <?php if ($columns['file']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='dateCreation'
												data-order='<?php echo intval($columns['dateCreation']['order']); ?>'
												data-width='<?php echo intval($columns['dateCreation']['width']); ?>'
												data-collapsed='<?php echo intval($columns['dateCreation']['collapsed']); ?>'
												style='width: <?php echo intval($columns['dateCreation']['width']); ?>px; <?php if ($columns['dateCreation']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_file_konto(); 
		}}, 600);
		date_filter(win, 'fop_fints_file_konto', 'dateCreation', <?php echo htmlentities(json_encode(_('period'))); ?>, <?php echo htmlentities(json_encode(\FOP\I18n::getShortLocale())); ?>, <?php echo htmlentities(json_encode(_('dateformat_moment'))); ?>, function() { reloadfop_fints_file_konto();  reloadfop_fints_file_konto(); });
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_fints_file_konto'] == 'dateCreation ASC') {
			query['sort_fop_fints_file_konto'] = 'dateCreation DESC';
		 } else if (query['sort_fop_fints_file_konto'] == 'dateCreation DESC') {
		 	delete query['sort_fop_fints_file_konto'];
		 } else {
			query['sort_fop_fints_file_konto'] = 'dateCreation ASC';
		 }
		 reloadfop_fints_file_konto();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Erstelldatum')); ?>'><?php echo(_('Erstelldatum')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'dateCreation ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'dateCreation DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_file_konto_dateCreation']) || isset($_GET['range_max_fop_fints_file_konto_dateCreation']) || isset($_GET['deps_fop_fints_file_konto_dateCreation']) || isset($_GET['fullsearch_fop_fints_file_konto_dateCreation']) || isset($_GET['dynamic_fop_fints_file_konto_dateCreation']) || isset($_GET['search_fop_fints_file_konto_dateCreation']) || isset($_GET['searchnot_fop_fints_file_konto_dateCreation']) || isset($_GET['filter_fop_fints_file_konto_dateCreation'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['dateCreation']['header'] = ob_get_contents(); ob_end_clean();
											$columns['dateCreation']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['dateCreation']['width']); ?>px; <?php if ($columns['dateCreation']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='dateCreation'><span class='overflow-text' title="<?php echo htmlentities(($item['dateCreation']) ? strftime(_('dateformat_php2'), intval($item['dateCreation'])) : ''); ?>"><?php echo htmlentities(($item['dateCreation']) ? strftime(_('dateformat_php2'), intval($item['dateCreation'])) : ''); ?></span></div><?php
											};
											$columns['dateCreation']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='dateCreation'
													data-order='<?php echo intval($columns['dateCreation']['order']); ?>'
													data-width='<?php echo intval($columns['dateCreation']['width']); ?>'
													data-collapsed='<?php echo intval($columns['dateCreation']['collapsed']); ?>'
													style='width: <?php echo intval($columns['dateCreation']['width']); ?>px; <?php if ($columns['dateCreation']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='dateExecution'
												data-order='<?php echo intval($columns['dateExecution']['order']); ?>'
												data-width='<?php echo intval($columns['dateExecution']['width']); ?>'
												data-collapsed='<?php echo intval($columns['dateExecution']['collapsed']); ?>'
												style='width: <?php echo intval($columns['dateExecution']['width']); ?>px; <?php if ($columns['dateExecution']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_file_konto(); 
		}}, 600);
		date_filter(win, 'fop_fints_file_konto', 'dateExecution', <?php echo htmlentities(json_encode(_('period'))); ?>, <?php echo htmlentities(json_encode(\FOP\I18n::getShortLocale())); ?>, <?php echo htmlentities(json_encode(_('dateformat_moment'))); ?>, function() { reloadfop_fints_file_konto();  reloadfop_fints_file_konto(); });
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_fints_file_konto'] == 'dateExecution ASC') {
			query['sort_fop_fints_file_konto'] = 'dateExecution DESC';
		 } else if (query['sort_fop_fints_file_konto'] == 'dateExecution DESC') {
		 	delete query['sort_fop_fints_file_konto'];
		 } else {
			query['sort_fop_fints_file_konto'] = 'dateExecution ASC';
		 }
		 reloadfop_fints_file_konto();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Durchführungsdatum')); ?>'><?php echo(_('Durchführungsdatum')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'dateExecution ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'dateExecution DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_file_konto_dateExecution']) || isset($_GET['range_max_fop_fints_file_konto_dateExecution']) || isset($_GET['deps_fop_fints_file_konto_dateExecution']) || isset($_GET['fullsearch_fop_fints_file_konto_dateExecution']) || isset($_GET['dynamic_fop_fints_file_konto_dateExecution']) || isset($_GET['search_fop_fints_file_konto_dateExecution']) || isset($_GET['searchnot_fop_fints_file_konto_dateExecution']) || isset($_GET['filter_fop_fints_file_konto_dateExecution'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['dateExecution']['header'] = ob_get_contents(); ob_end_clean();
											$columns['dateExecution']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['dateExecution']['width']); ?>px; <?php if ($columns['dateExecution']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='dateExecution'><span class='overflow-text' title="<?php echo htmlentities(($item['dateExecution']) ? strftime(_('dateformat_php2'), intval($item['dateExecution'])) : ''); ?>"><?php echo htmlentities(($item['dateExecution']) ? strftime(_('dateformat_php2'), intval($item['dateExecution'])) : ''); ?></span></div><?php
											};
											$columns['dateExecution']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='dateExecution'
													data-order='<?php echo intval($columns['dateExecution']['order']); ?>'
													data-width='<?php echo intval($columns['dateExecution']['width']); ?>'
													data-collapsed='<?php echo intval($columns['dateExecution']['collapsed']); ?>'
													style='width: <?php echo intval($columns['dateExecution']['width']); ?>px; <?php if ($columns['dateExecution']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='message'
												data-order='<?php echo intval($columns['message']['order']); ?>'
												data-width='<?php echo intval($columns['message']['width']); ?>'
												data-collapsed='<?php echo intval($columns['message']['collapsed']); ?>'
												style='width: <?php echo intval($columns['message']['width']); ?>px; <?php if ($columns['message']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_fints_file_konto(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_fints_file_konto_message'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_fints_file_konto_message'] = text.val(); } else { delete query['search_fop_fints_file_konto_message']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_fints_file_konto').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_fints_file_konto_message'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_fints_file_konto_message'] = text2.val(); } else { delete query['searchnot_fop_fints_file_konto_message']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_fints_file_konto').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_fints_file_konto'] == 'message ASC') {
			query['sort_fop_fints_file_konto'] = 'message DESC';
		 } else if (query['sort_fop_fints_file_konto'] == 'message DESC') {
		 	delete query['sort_fop_fints_file_konto'];
		 } else {
			query['sort_fop_fints_file_konto'] = 'message ASC';
		 }
		 reloadfop_fints_file_konto();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Meldung Transaktion')); ?>'><?php echo(_('Meldung Transaktion')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'message ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_fints_file_konto']) && $_GET['sort_fop_fints_file_konto'] == 'message DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_fints_file_konto_message']) || isset($_GET['range_max_fop_fints_file_konto_message']) || isset($_GET['deps_fop_fints_file_konto_message']) || isset($_GET['fullsearch_fop_fints_file_konto_message']) || isset($_GET['dynamic_fop_fints_file_konto_message']) || isset($_GET['search_fop_fints_file_konto_message']) || isset($_GET['searchnot_fop_fints_file_konto_message']) || isset($_GET['filter_fop_fints_file_konto_message'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['message']['header'] = ob_get_contents(); ob_end_clean();
											$columns['message']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['message']['width']); ?>px; <?php if ($columns['message']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='message'><span class='overflow-text' title="<?php echo htmlentities($item['message']); ?>"><?php echo (str_replace("\n", "&#x23ce;", htmlentities(mb_substr($item['message'], 0, 40)))) . (strlen($item['message']) >= 40 ? '…' : ''); ?></span></div><?php
											};
											$columns['message']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='message'
													data-order='<?php echo intval($columns['message']['order']); ?>'
													data-width='<?php echo intval($columns['message']['width']); ?>'
													data-collapsed='<?php echo intval($columns['message']['collapsed']); ?>'
													style='width: <?php echo intval($columns['message']['width']); ?>px; <?php if ($columns['message']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#fop_fints_file_konto-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#fop_fints_file_konto-table .fop-table-header .fop-table-column .title,
										#fop_fints_file_konto-table .fop-column-handle,
										#fop_fints_file_konto-table .fop-table-row,
										#fop_fints_file_konto-table .fop-table-row .fop-table-column,
										#fop_fints_file_konto-table .fop-table-column-multicontrol,
										#fop_fints_file_konto-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="fop_fints_file_konto">
											<div class="fop-legend">
													<div class="fop-legend-item">
														<div class="fop-legend-item-color" style="background: #ff000020;"></div>
														<?php echo(_('Fehler')); ?>
													</div>
												
													<div class="fop-legend-item">
														<div class="fop-legend-item-color" style="background: #44ff0020;"></div>
														<?php echo(_('Erfolg')); ?>
													</div>
												
													<div class="fop-legend-item">
														<div class="fop-legend-item-color" style="background: #0000ff20;"></div>
														<?php echo(_('Neu')); ?>
													</div>
												</div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="fop_fints_file_konto__all-checkbox">
														<input class="mdl-checkbox__input" id="fop_fints_file_konto__all-checkbox" type="checkbox" onchange="checkfop_fints_file_konto('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_fints_file_konto__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Fop_fints_file_konto/permissions?id=' + checkfop_fints_file_konto(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_fop_fints_file_konto_') == 0 || key.indexOf('range_max_fop_fints_file_konto_') == 0 || key.indexOf('deps_fop_fints_file_konto_') == 0 || key.indexOf('fullsearch_fop_fints_file_konto_') == 0 || key.indexOf('dynamic_fop_fints_file_konto_') == 0 || key.indexOf('search_fop_fints_file_konto_') == 0 || key.indexOf('searchnot_fop_fints_file_konto_') == 0 || key.indexOf('filter_fop_fints_file_konto_') == 0) delete query[key]; reloadfop_fints_file_konto(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_fop_fints_file_konto_ID'] = checkfop_fints_file_konto(null, 'ID'); delete query['page_fop_fints_file_konto']; reloadfop_fints_file_konto(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkfop_fints_file_konto(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkfop_fints_file_konto(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((\FOP\User::getBuchhaltung()))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Fop_fints_file/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkfop_fints_file_konto(null, 'ID'))).then(function () { reloadfop_fints_file_konto(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('fop_fints_file_konto', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'fop_fints_file_konto', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_fop_fints_file_konto" <?php \EasyEditor\Navigation::printScroll('dv.Fop_fints_file_konto', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_fop_fints_file_konto\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_fop_fints_file_konto\'] = wantedPage;
														reloadfop_fints_file_konto(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="<?php echo 'background: ' .htmlentities((function ($item) {return $item['::color'];})($item)).'!important;'; ?> " data-fop_fints_file-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadfop_fints_file_konto({action: \'open\', fop_table: \'fop_fints_file\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox fop_fints_file_konto__checkbox fop_fints_file_konto__checkbox fop_fints_file_konto__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="fop_fints_file_konto__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="fop_fints_file_konto__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkfop_fints_file_konto(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_fints_file_konto__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-fop_fints_file_konto-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadfop_fints_file_konto({action: 'open', fop_table: 'fop_fints_file', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="manual_success" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::manualURL2(['id' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">done</i></span><span class="fop-menu-caption" title="<?php echo(_('Als extern durchgeführt markieren')); ?>"><?php echo(_('Als extern durchgeführt markieren')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="sendSepa" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::sendSepaURL2(['id' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">local_atm</i></span><span class="fop-menu-caption" title="<?php echo(_('SEPA anweisen')); ?>"><?php echo(_('SEPA anweisen')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Fop_fints_file/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadfop_fints_file_konto(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_fints_file" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="manual_success" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::manualURL2(['id' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_fints_file_konto();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('Als extern durchgeführt markieren')); ?>">
				<i class="material-icons">done</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_fints_file" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_fints_file_konto();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_fints_file" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\Fop_fints_file::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadfop_fints_file_konto({action: 'open', fop_table: 'fop_fints_file', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadfop_fints_file_konto();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function renderScript($id) { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_fop_fints_file_konto_kontoListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_fints_file_konto_konto', val, cb.checked);
		  } else {
			  delete query['filter_fop_fints_file_konto_konto'];
		  }reloadfop_fints_file_konto();
        
    }

		var i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout = null;
		function changefilter_fop_fints_file_konto_kontoSearchFilter(val, callback) {
			if(i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout) clearTimeout(i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout);

			i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout = setTimeout(function() {
				$.getJSON(reloadfop_fints_file_konto({action: 'getfilter_fop_fints_file_konto_kontoItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_fints_file_konto_konto_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_fints_file_konto_kontoListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_fints_file_konto_konto_orig']) ? json_encode($_GET['filter_fop_fints_file_konto_konto_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cf" type="text">' +
			'<label class="mdl-textfield__label" for="445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cf">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_fints_file_konto_konto', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_fints_file_konto_konto_orig'] = '';
					delete query['filter_fop_fints_file_konto_konto'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_fints_file_konto();
					
				} else {
					$('#table_fop_fints_file_konto').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_fints_file_konto_kontoSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_fints_file_konto::getfilter_fop_fints_file_konto_kontoItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_fints_file_konto_konto_orig'] = '';
				delete query['filter_fop_fints_file_konto_konto'];
				reload('', items);reloadfop_fints_file_konto();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_fints_file_konto_konto', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_fints_file_konto_kontoListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_fop_fints_file_konto_kontoListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_fints_file_konto_konto', val, cb.checked);
		  } else {
			  delete query['filter_fop_fints_file_konto_konto'];
		  }reloadfop_fints_file_konto();
        
    }

		var i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout = null;
		function changefilter_fop_fints_file_konto_kontoSearchFilter(val, callback) {
			if(i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout) clearTimeout(i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout);

			i445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cftimeout = setTimeout(function() {
				$.getJSON(reloadfop_fints_file_konto({action: 'getfilter_fop_fints_file_konto_kontoItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_fints_file_konto_konto_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_fints_file_konto_kontoListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_fints_file_konto_konto_orig']) ? json_encode($_GET['filter_fop_fints_file_konto_konto_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cf" type="text">' +
			'<label class="mdl-textfield__label" for="445fd1609eead73971a19c2eac208a62f445ca9fd704548343736b8184ac60cf">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_fints_file_konto_konto', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_fints_file_konto_konto_orig'] = '';
					delete query['filter_fop_fints_file_konto_konto'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_fints_file_konto();
					
				} else {
					$('#table_fop_fints_file_konto').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_fints_file_konto_kontoSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_fints_file_konto::getfilter_fop_fints_file_konto_kontoItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_fints_file_konto_konto_orig'] = '';
				delete query['filter_fop_fints_file_konto_konto'];
				reload('', items);reloadfop_fints_file_konto();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_fints_file_konto_konto', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_fints_file_konto_kontoListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumberfop_fints_file_konto(col) {
										//var checklist = window.DataViewChecked['fop_fints_file_konto'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['fop_fints_file_konto'] && window.DataViewChecked['fop_fints_file_konto'][col].ranges.length > 0) {
											$('.fop_fints_file_konto__mass-action').css('visibility', 'visible');
											$('.fop_fints_file_konto__action').css('visibility', 'hidden');
										} else {
											$('.fop_fints_file_konto__mass-action').css('visibility', 'hidden');
											$('.fop_fints_file_konto__action').css('visibility', 'visible');
										}
										$('.fop_fints_file_konto__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('fop_fints_file_konto__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('fop_fints_file_konto__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadfop_fints_file_konto (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										nq["id"] = <?php echo json_encode($id); ?>; 
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Fop_fints_file_konto/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if (((\FOP\User::getBuchhaltung())) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Fop_fints_file_konto/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#fop_fints_file_konto-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#fop_fints_file_konto-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#fop_fints_file_konto-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberfop_fints_file_konto('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#fop_fints_file_konto-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadfop_fints_file_konto()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkfop_fints_file_konto (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['fop_fints_file_konto']) window.DataViewChecked['fop_fints_file_konto'] = {};
										if (!window.DataViewChecked['fop_fints_file_konto'][col]) window.DataViewChecked['fop_fints_file_konto'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['fop_fints_file_konto'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadfop_fints_file_konto({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['fop_fints_file_konto'][col] = new IDList(ids);
													updateNumberfop_fints_file_konto(col);
												});
											} else {
												window.DataViewChecked['fop_fints_file_konto'][col] = new IDList();
												updateNumberfop_fints_file_konto(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#fop_fints_file_konto__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['fop_fints_file_konto'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['fop_fints_file_konto'][col].push(id);
												} else {
													window.DataViewChecked['fop_fints_file_konto'][col].remove(id);
												}
											}
											updateNumberfop_fints_file_konto(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadfop_fints_file_konto();
			
		}

	</script>
	<?php
	
    
  }

  public static function getSQL($params, $id) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ::color */ CASE  WHEN (('.qi('fop_fints_file').'.'.qi('status').') > (2)) AND (('.qi('fop_fints_file').'.'.qi('status').') < (6)) THEN (\'#ff000020\')  WHEN (('.qi('fop_fints_file').'.'.qi('status').') > (2)) AND (('.qi('fop_fints_file').'.'.qi('status').') < (6)) THEN (\'#ff000020\')  WHEN (('.qi('fop_fints_file').'.'.qi('status').') = (2)) OR (('.qi('fop_fints_file').'.'.qi('status').') = (6)) THEN (\'#44ff0020\')  WHEN (('.qi('fop_fints_file').'.'.qi('status').') = (2)) OR (('.qi('fop_fints_file').'.'.qi('status').') = (6)) THEN (\'#44ff0020\')  WHEN ('.qi('fop_fints_file').'.'.qi('status').') = (1) THEN (\'#0000ff20\')  WHEN ('.qi('fop_fints_file').'.'.qi('status').') = (1) THEN (\'#0000ff20\')  ELSE NULL END AS '.qi('::color').',
									/* ID */ '.qi('ID').' AS '.qi('ID').',
									/* dateCreation */ '.qi('dateCreation').' AS '.qi('dateCreation').',
									/* dateExecution */ '.qi('dateExecution').' AS '.qi('dateExecution').',
									/* file */ '.qi('file').' AS '.qi('file').',
									/* konto */ '.qi('konto').' AS '.qi('konto').',
									/* konto::canView */ '.qi('ref:konto').'.'.qi('konto:canView').' AS '.qi('konto::canView').',
									/* konto::description */ '.qi('ref:konto').'.'.qi('konto:description').' AS '.qi('konto::description').',
									/* message */ '.qi('message').' AS '.qi('message').',
									/* operation::create */ ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::create').',
									/* operation::delete */ (CASE WHEN FALSE THEN TRUE ELSE NOT ((('.qi('fop_fints_file').'.'.qi('status').') = (2)) OR (('.qi('fop_fints_file').'.'.qi('status').') = (6))) END) AND ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::delete').',
									/* operation::edit */ (CASE WHEN FALSE THEN TRUE ELSE NOT ((('.qi('fop_fints_file').'.'.qi('status').') = (2)) OR (('.qi('fop_fints_file').'.'.qi('status').') = (6))) END) AND ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::view').',
									/* status */ '.qi('status').' AS '.qi('status').',
									1
								FROM '.qi('fop_fints_file').' '.qi('fop_fints_file').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('konto:ID').', '.qi('fop_fints_konto').'.'.qi('kontoname').' AS '.qi('konto:description').', (('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).')) AS '.qi('konto:canView').' FROM '.qi('fop_fints_konto').') '.qi('ref:konto').' ON '.qi('ref:konto').'.'.qi('konto:ID').' = '.qi('konto').'
								WHERE ('.qi('konto').' = ' . \FOP\Database::quote($id) . ')
									AND (('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).'))) AS t
								WHERE ' . (isset($params['range_min_fop_fints_file_konto_dateCreation']) ? ($params['range_min_fop_fints_file_konto_dateCreation'] !== '' && is_numeric($params['range_min_fop_fints_file_konto_dateCreation']) ? 't.'.qi('dateCreation').' >= ' . \FOP\Database::quote($params['range_min_fop_fints_file_konto_dateCreation']) . ' AND ' : '') : '') . 
								(isset($params['range_min_fop_fints_file_konto_dateExecution']) ? ($params['range_min_fop_fints_file_konto_dateExecution'] !== '' && is_numeric($params['range_min_fop_fints_file_konto_dateExecution']) ? 't.'.qi('dateExecution').' >= ' . \FOP\Database::quote($params['range_min_fop_fints_file_konto_dateExecution']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_fints_file_konto_dateCreation']) ? ($params['range_max_fop_fints_file_konto_dateCreation'] !== '' && is_numeric($params['range_max_fop_fints_file_konto_dateCreation']) ? 't.'.qi('dateCreation').' <= ' . \FOP\Database::quote($params['range_max_fop_fints_file_konto_dateCreation']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_fints_file_konto_dateExecution']) ? ($params['range_max_fop_fints_file_konto_dateExecution'] !== '' && is_numeric($params['range_max_fop_fints_file_konto_dateExecution']) ? 't.'.qi('dateExecution').' <= ' . \FOP\Database::quote($params['range_max_fop_fints_file_konto_dateExecution']) . ' AND ' : '') : '') . 
								(isset($params['fullsearch_fop_fints_file_konto_file']) && $params['fullsearch_fop_fints_file_konto_file'] ? 't.'.qi('file').' IN (SELECT '.qi('ID').' FROM fop_files WHERE filename LIKE '.\FOP\Database::quote('%' . $params['fullsearch_fop_fints_file_konto_file'] . '%').') AND ' : '') . 
								(isset($params['filter_fop_fints_file_konto_konto']) ? ($params['filter_fop_fints_file_konto_konto'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_file_konto_konto']))->toSQL('t.'.qi('konto').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_file_konto_status']) ? ($params['filter_fop_fints_file_konto_status'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_file_konto_status']))->toSQL('t.'.qi('status').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_file_konto_file']) ? ($params['filter_fop_fints_file_konto_file'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_file_konto_file']))->toSQL('t.'.qi('file').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_file_konto_dateCreation']) ? ($params['filter_fop_fints_file_konto_dateCreation'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_file_konto_dateCreation']))->toSQL('t.'.qi('dateCreation').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_file_konto_dateExecution']) ? ($params['filter_fop_fints_file_konto_dateExecution'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_file_konto_dateExecution']))->toSQL('t.'.qi('dateExecution').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_file_konto_message']) ? ($params['filter_fop_fints_file_konto_message'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_file_konto_message']))->toSQL('t.'.qi('message').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_fints_file_konto_ID']) ? ($params['filter_fop_fints_file_konto_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_fints_file_konto_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_fop_fints_file_konto_message']) ? 't.'.qi('message').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_fints_file_konto_message'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_fints_file_konto_message']) ? 'NOT t.'.qi('message').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_fints_file_konto_message'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_fints_file_konto']) ? '(' . 't.'.qi('message').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_fints_file_konto'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getidsAction($col, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET, $id));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ((CASE WHEN FALSE THEN TRUE ELSE NOT ((('.qi('fop_fints_file').'.'.qi('status').') = (2)) OR (('.qi('fop_fints_file').'.'.qi('status').') = (6))) END) AND ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).')) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('fop_fints_file').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getfilter_fop_fints_file_konto_kontoItemsByStringAction($fstr, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_fop_fints_file_konto_konto']);
		return \Types\Fop_fints_konto::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('konto').''.self::getSQL($params, $id).')');
	

    
  }

  public static function getData($sqladdon, $params, $id, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params, $id);

								$order = (\FOP\Util::array_value(array(
									'message ASC' => 'ORDER BY t.'.qi('message').' ASC',
									'dateCreation ASC' => 'ORDER BY t.'.qi('dateCreation').' ASC',
									'dateExecution ASC' => 'ORDER BY t.'.qi('dateExecution').' ASC',
									'message DESC' => 'ORDER BY t.'.qi('message').' DESC',
									'dateCreation DESC' => 'ORDER BY t.'.qi('dateCreation').' DESC',
									'dateExecution DESC' => 'ORDER BY t.'.qi('dateExecution').' DESC',
									'' => ''), isset($params['sort_fop_fints_file_konto']) ? $params['sort_fop_fints_file_konto'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('dateCreation').' DESC');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['konto'] = \FOP\Sanitizers::null_converter($item['konto']);
											$item['status'] = \FOP\Util::IntStringNull($item['status']);
											$item['file'] = intval($item['file']);
											$item['dateCreation'] = intval($item['dateCreation']);
											$item['dateExecution'] = intval($item['dateExecution']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['konto'] = \FOP\Sanitizers::null_converter($item['konto']);
										$item['status'] = \FOP\Util::IntStringNull($item['status']);
										$item['file'] = intval($item['file']);
										$item['dateCreation'] = intval($item['dateCreation']);
										$item['dateExecution'] = intval($item['dateExecution']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	
	if ( // Corner Case: Monat
		isset($params['range_min_fop_fints_file_konto_dateCreation'])
		&& isset($params['range_max_fop_fints_file_konto_dateCreation'])
		&& (date('d', $params['range_min_fop_fints_file_konto_dateCreation']) == '01') //check first day of month
		&& (date('d', $params['range_max_fop_fints_file_konto_dateCreation']) == date('t', $params['range_max_fop_fints_file_konto_dateCreation'])) //check last day of month
		&& (date('Y-m', $params['range_min_fop_fints_file_konto_dateCreation']) == date('Y-m', $params['range_max_fop_fints_file_konto_dateCreation'])) //check if same year and month
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('first day of last month', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day of last month', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('first day of next month', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day of next month', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Erstelldatum') . ': ' . strftime('%B', $params['range_min_fop_fints_file_konto_dateCreation']) . ' ' . date('Y', $params['range_min_fop_fints_file_konto_dateCreation']))
		]);
	} else if ( // Corner Case: Tag
		isset($params['range_min_fop_fints_file_konto_dateCreation'])
		&& isset($params['range_max_fop_fints_file_konto_dateCreation'])
		&& (date('Y-m-d', $params['range_min_fop_fints_file_konto_dateCreation']) == (date('Y-m-d', $params['range_max_fop_fints_file_konto_dateCreation'])))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Erstelldatum') . ': ' . date('d.m.Y', $params['range_min_fop_fints_file_konto_dateCreation']))
		]);
	} else if ( // Corner Case: Jahr
		isset($params['range_min_fop_fints_file_konto_dateCreation'])
		&& isset($params['range_max_fop_fints_file_konto_dateCreation'])
		&& (date('Y', $params['range_min_fop_fints_file_konto_dateCreation']) == (date('Y', $params['range_max_fop_fints_file_konto_dateCreation'])))
		&& ((date('m-d', $params['range_min_fop_fints_file_konto_dateCreation']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateCreation']) == '12-31'))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('first day of January last year', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day of December last year', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('first day of January next year', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day of December next year', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Erstelldatum') . ': ' . date('Y', $params['range_min_fop_fints_file_konto_dateCreation']))
		]);
	} else if ( // Corner Case: Quartal
		isset($params['range_min_fop_fints_file_konto_dateCreation'])
		&& isset($params['range_max_fop_fints_file_konto_dateCreation'])
		&& ( (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateCreation']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateCreation']) == '03-31')) )
		|| (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateCreation']) == '04-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateCreation']) == '06-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateCreation']) == '07-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateCreation']) == '09-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateCreation']) == '10-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateCreation']) == '12-31')) )
	) ) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
					query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('first day of -3 months', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
					query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day of -3 months', $params['range_max_fop_fints_file_konto_dateCreation']).'&apos;;
					reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('first day of +3 months', $params['range_min_fop_fints_file_konto_dateCreation']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateCreation&apos;] = &apos;'.strtotime('last day of +3 months', $params['range_max_fop_fints_file_konto_dateCreation']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),	
			htmlentities(_('Erstelldatum') . ': Q' . (ceil((date('m', $params['range_min_fop_fints_file_konto_dateCreation']))/3)) . ' (' . date('d.m.', $params['range_min_fop_fints_file_konto_dateCreation']) . ' - ' . date('d.m.Y', $params['range_max_fop_fints_file_konto_dateCreation']) . ')')
		]);
	}
	else if (isset($params['range_min_fop_fints_file_konto_dateCreation']) && isset($params['range_max_fop_fints_file_konto_dateCreation'])) {
		array_push($filters, _('Erstelldatum') . ': ' . (($params['range_min_fop_fints_file_konto_dateCreation']) ? strftime(_('dateformat_php2'), intval($params['range_min_fop_fints_file_konto_dateCreation'])) : '') . ' ' . _('filters_between') . ' ' . (($params['range_max_fop_fints_file_konto_dateCreation']) ? strftime(_('dateformat_php2'), intval($params['range_max_fop_fints_file_konto_dateCreation'])) : ''));
	} else if (isset($params['range_min_fop_fints_file_konto_dateCreation'])) {
		array_push($filters, _('Erstelldatum') . ': ' . _('filters_from') . ' ' . (($params['range_min_fop_fints_file_konto_dateCreation']) ? strftime(_('dateformat_php2'), intval($params['range_min_fop_fints_file_konto_dateCreation'])) : ''));
	} else if (isset($params['range_max_fop_fints_file_konto_dateCreation'])) {
		array_push($filters, _('Erstelldatum') . ': ' . _('filters_to') . ' ' . (($params['range_max_fop_fints_file_konto_dateCreation']) ? strftime(_('dateformat_php2'), intval($params['range_max_fop_fints_file_konto_dateCreation'])) : ''));
	}
	
	if ( // Corner Case: Monat
		isset($params['range_min_fop_fints_file_konto_dateExecution'])
		&& isset($params['range_max_fop_fints_file_konto_dateExecution'])
		&& (date('d', $params['range_min_fop_fints_file_konto_dateExecution']) == '01') //check first day of month
		&& (date('d', $params['range_max_fop_fints_file_konto_dateExecution']) == date('t', $params['range_max_fop_fints_file_konto_dateExecution'])) //check last day of month
		&& (date('Y-m', $params['range_min_fop_fints_file_konto_dateExecution']) == date('Y-m', $params['range_max_fop_fints_file_konto_dateExecution'])) //check if same year and month
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('first day of last month', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day of last month', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('first day of next month', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day of next month', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Durchführungsdatum') . ': ' . strftime('%B', $params['range_min_fop_fints_file_konto_dateExecution']) . ' ' . date('Y', $params['range_min_fop_fints_file_konto_dateExecution']))
		]);
	} else if ( // Corner Case: Tag
		isset($params['range_min_fop_fints_file_konto_dateExecution'])
		&& isset($params['range_max_fop_fints_file_konto_dateExecution'])
		&& (date('Y-m-d', $params['range_min_fop_fints_file_konto_dateExecution']) == (date('Y-m-d', $params['range_max_fop_fints_file_konto_dateExecution'])))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Durchführungsdatum') . ': ' . date('d.m.Y', $params['range_min_fop_fints_file_konto_dateExecution']))
		]);
	} else if ( // Corner Case: Jahr
		isset($params['range_min_fop_fints_file_konto_dateExecution'])
		&& isset($params['range_max_fop_fints_file_konto_dateExecution'])
		&& (date('Y', $params['range_min_fop_fints_file_konto_dateExecution']) == (date('Y', $params['range_max_fop_fints_file_konto_dateExecution'])))
		&& ((date('m-d', $params['range_min_fop_fints_file_konto_dateExecution']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateExecution']) == '12-31'))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('first day of January last year', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day of December last year', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('first day of January next year', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day of December next year', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Durchführungsdatum') . ': ' . date('Y', $params['range_min_fop_fints_file_konto_dateExecution']))
		]);
	} else if ( // Corner Case: Quartal
		isset($params['range_min_fop_fints_file_konto_dateExecution'])
		&& isset($params['range_max_fop_fints_file_konto_dateExecution'])
		&& ( (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateExecution']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateExecution']) == '03-31')) )
		|| (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateExecution']) == '04-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateExecution']) == '06-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateExecution']) == '07-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateExecution']) == '09-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_fints_file_konto_dateExecution']) == '10-01'))
		&& ((date('m-d', $params['range_max_fop_fints_file_konto_dateExecution']) == '12-31')) )
	) ) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
					query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('first day of -3 months', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
					query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day of -3 months', $params['range_max_fop_fints_file_konto_dateExecution']).'&apos;;
					reloadfop_fints_file_konto(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('first day of +3 months', $params['range_min_fop_fints_file_konto_dateExecution']).'&apos;;
				query[&apos;range_max_fop_fints_file_konto_dateExecution&apos;] = &apos;'.strtotime('last day of +3 months', $params['range_max_fop_fints_file_konto_dateExecution']).'&apos;;
				reloadfop_fints_file_konto(); ">add_circle_outline</i>' : ''),	
			htmlentities(_('Durchführungsdatum') . ': Q' . (ceil((date('m', $params['range_min_fop_fints_file_konto_dateExecution']))/3)) . ' (' . date('d.m.', $params['range_min_fop_fints_file_konto_dateExecution']) . ' - ' . date('d.m.Y', $params['range_max_fop_fints_file_konto_dateExecution']) . ')')
		]);
	}
	else if (isset($params['range_min_fop_fints_file_konto_dateExecution']) && isset($params['range_max_fop_fints_file_konto_dateExecution'])) {
		array_push($filters, _('Durchführungsdatum') . ': ' . (($params['range_min_fop_fints_file_konto_dateExecution']) ? strftime(_('dateformat_php2'), intval($params['range_min_fop_fints_file_konto_dateExecution'])) : '') . ' ' . _('filters_between') . ' ' . (($params['range_max_fop_fints_file_konto_dateExecution']) ? strftime(_('dateformat_php2'), intval($params['range_max_fop_fints_file_konto_dateExecution'])) : ''));
	} else if (isset($params['range_min_fop_fints_file_konto_dateExecution'])) {
		array_push($filters, _('Durchführungsdatum') . ': ' . _('filters_from') . ' ' . (($params['range_min_fop_fints_file_konto_dateExecution']) ? strftime(_('dateformat_php2'), intval($params['range_min_fop_fints_file_konto_dateExecution'])) : ''));
	} else if (isset($params['range_max_fop_fints_file_konto_dateExecution'])) {
		array_push($filters, _('Durchführungsdatum') . ': ' . _('filters_to') . ' ' . (($params['range_max_fop_fints_file_konto_dateExecution']) ? strftime(_('dateformat_php2'), intval($params['range_max_fop_fints_file_konto_dateExecution'])) : ''));
	}if (isset($params['fullsearch_fop_fints_file_konto_file'])) {
		array_push($filters, _('file') . ' ' . _('filter_contains') . ' ' . $params['fullsearch_fop_fints_file_konto_file']);
	}if (isset($params['filter_fop_fints_file_konto_status'])) {
		if ($params['filter_fop_fints_file_konto_status'] == '_null') {
			array_push($filters, _('Status') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_file_konto_status']))->all() AS $val) {
				$value = \Types\Fop_fints_file_state::toString($val);
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Status') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_file_konto_file'])) {
		if ($params['filter_fop_fints_file_konto_file'] == '_null') {
			array_push($filters, _('SEPA-Datei') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_file_konto_file']))->all() AS $val) {
				$value = \FOP\Database::query('SELECT filename FROM fop_files WHERE '.qi('ID').' = ' . intval($val))->fetchColumn();
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('SEPA-Datei') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_file_konto_dateCreation'])) {
		if ($params['filter_fop_fints_file_konto_dateCreation'] == '_null') {
			array_push($filters, _('Erstelldatum') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_file_konto_dateCreation']))->all() AS $val) {
				$value = ($val) ? strftime(_('dateformat_php2'), intval($val)) : '';
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Erstelldatum') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_file_konto_dateExecution'])) {
		if ($params['filter_fop_fints_file_konto_dateExecution'] == '_null') {
			array_push($filters, _('Durchführungsdatum') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_file_konto_dateExecution']))->all() AS $val) {
				$value = ($val) ? strftime(_('dateformat_php2'), intval($val)) : '';
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Durchführungsdatum') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_file_konto_message'])) {
		if ($params['filter_fop_fints_file_konto_message'] == '_null') {
			array_push($filters, _('Meldung Transaktion') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_file_konto_message']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Meldung Transaktion') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_fints_file_konto_konto'])) {
		if ($params['filter_fop_fints_file_konto_konto'] == '_null') {
			array_push($filters, _('Konto') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_fints_file_konto_konto']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT '.qi('fop_fints_konto').'.'.qi('kontoname').' AS description FROM '.qi('fop_fints_konto').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Konto') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_fop_fints_file_konto_message'])) {
		array_push($filters, _('message') . ' ' . _('filter_contains') . ' ' . $params['search_fop_fints_file_konto_message']);
	}if (isset($params['searchnot_fop_fints_file_konto_message'])) {
		array_push($filters, _('message') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_fints_file_konto_message']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_fop_fints_file_konto_\')) delete query[q];} reloadfop_fints_file_konto(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'fop_fints_file') {
	\FOP\Session::setPayload('dv-fop_fints_file', [
		'id' => 'fop_fints_file_konto',
		'tbl' => 'fop_fints_file',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Fop_fints_file_konto::stepURL('fop_fints_file', 'XXX', -1),
		'next' => \DataViewRouter\Fop_fints_file_konto::stepURL('fop_fints_file', 'XXX',  1),
		'from' => $fop_from,
		'param_id' => $id
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Fop_fints_file::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query, $dv['param_id']);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



